<xsl:stylesheet version='1.0'
 xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
 xmlns:xsd='http://www.w3.org/2001/XMLSchema'
 xmlns:oailr='http://www.openarchives.org/OAI/1.1/OAI_ListRecords'
 xmlns:xoailr='http://oai.dlib.vt.edu/XOAI/1.0/XOAI_ListRecords'
 xmlns:oaigr='http://www.openarchives.org/OAI/1.1/OAI_GetRecord'
 xmlns:xoaigr='http://oai.dlib.vt.edu/XOAI/1.0/XOAI_GetRecord'
 xmlns:hits='http://oai.dlib.vt.edu/ODL/Search/1.0/responsecontainer'
 xmlns:level='http://oai.dlib.vt.edu/ODL/Annotate/1.0/level'
 xmlns:discuss='http://ODLThread'>

   <xsl:output method="html"/>

   <xsl:variable name="pagesize" select="50"/>
   
   <xsl:template match="forum">
      <html>
         <head>
            <title>Open Digital Libraries Discussion Forum</title>
            <style type="text/css">DIV[class=messidx] { margin-left: 15pt; margin-top: 0pt; margin-bottom: 0pt; }</style>
         </head>
         <body bgcolor="#ddffff">
            <center><h2>Open Digital Libraries Discussion Forum</h2></center>
            <hr/>
            <font size="3">
               <center>[ <a href="forum.pl">forum index</a> ] [ <a href="#post">post message</a> ] [ <a href="http://oai.dlib.vt.edu/odl">ODL homepage</a>] </center>
            </font>
            <xsl:choose>
               <xsl:when test="identifier='' and start=''">
                  <xsl:call-template name="current">
                     <xsl:with-param name="baseURL" select="baseURL"/>
                     <xsl:with-param name="identifier">top</xsl:with-param>
                     <xsl:with-param name="startpage">1</xsl:with-param>
                  </xsl:call-template>
               </xsl:when>
               <xsl:when test="identifier='' and start!=''">
                  <xsl:call-template name="current">
                     <xsl:with-param name="baseURL" select="baseURL"/>
                     <xsl:with-param name="identifier">top</xsl:with-param>
                     <xsl:with-param name="startpage" select="start"/>
                  </xsl:call-template>
               </xsl:when>
               <xsl:when test="identifier!='' and start=''">
                  <xsl:call-template name="current">
                     <xsl:with-param name="baseURL" select="baseURL"/>
                     <xsl:with-param name="identifier" select="identifier"/>
                     <xsl:with-param name="startpage">1</xsl:with-param>
                  </xsl:call-template>
               </xsl:when>
               <xsl:when test="identifier!='' and start!=''">
                  <xsl:call-template name="current">
                     <xsl:with-param name="baseURL" select="baseURL"/>
                     <xsl:with-param name="identifier" select="identifier"/>
                     <xsl:with-param name="startpage" select="start"/>
                  </xsl:call-template>
               </xsl:when>
            </xsl:choose>
            <hr/>
            <center>this software is produced as part of the 
            <a href="http://oai.dlib.vt.edu/odl">Open Digital Libraries</a>
            project.</center>
         </body>
      </html>
   </xsl:template>
   
   <xsl:template name="current">
      <xsl:param name="identifier"/>
      <xsl:param name="startpage"/>
      <xsl:param name="baseURL"/>
      
      <xsl:variable name="start" select="(($startpage - 1) * $pagesize) + 1"/>
      <xsl:variable name="stop" select="$start + $pagesize - 1"/>

      <xsl:variable name="parent" select="document (concat ($baseURL, '?verb=GetRecord&amp;metadataPrefix=annotation&amp;identifier=parent/', $identifier))/xoaigr:GetRecord"/>
      <xsl:variable name="message" select="document (concat ($baseURL, '?verb=GetRecord&amp;metadataPrefix=annotation&amp;identifier=', $identifier))/xoaigr:GetRecord"/>

      <xsl:if test="$message/oaigr:record">
         <hr/>
         <xsl:for-each select="$message/oaigr:record/oaigr:metadata/discuss:discuss">
            <center><h2><xsl:value-of select="discuss:subject"/></h2></center>
            <p><font size="-1">
            message posted by <b><xsl:apply-templates select="discuss:from"/></b> on <i><xsl:value-of select="discuss:datestamp"/></i>
            <xsl:for-each select="$parent/oaigr:record/oaigr:metadata/discuss:discuss">
               <br/>
               in reply to <a href="forum.pl?identifier={../../oaigr:header/oaigr:identifier}"><b><xsl:value-of select="discuss:subject"/></b></a> posted by
               <b><xsl:apply-templates select="discuss:from"/></b> on <i><xsl:value-of select="discuss:datestamp"/></i>
            </xsl:for-each>
            </font></p>
            <p><xsl:copy-of select="discuss:body"/></p>
         </xsl:for-each>
      </xsl:if>

      <xsl:variable name="replies" select="document (concat ($baseURL, '?verb=ListRecords&amp;metadataPrefix=annotation&amp;set=', $start, '/', $stop, '/', $identifier))/xoailr:ListRecords"/>
      <xsl:variable name="hits" select="$replies/xoailr:responseContainer/hits:hits"/>
      <xsl:variable name="minlevel" select="$message/oaigr:record/oaigr:about/level:level"/>

      <xsl:if test="$replies/oailr:record">
         <hr/>
         <center><table width="90%"><tr><td>
         <b>
            <xsl:choose>
               <xsl:when test="$identifier!='top'">
                  replies
               </xsl:when>
               <xsl:otherwise>
                  message index
               </xsl:otherwise>
            </xsl:choose>
         </b>

         <xsl:if test="($hits > $pagesize) and ($identifier='top')">
            <form action="forum.pl" name="page2">
               <input type="hidden" name="identifier" value="{$identifier}"/>
               <table cellpadding="4" cellspacing="3" border="0" width="100%" align="center">
                  <tr>
                     <td align="left" bgcolor="#ffaaaa" width="*"><i>displaying page <xsl:value-of select="floor($start div $pagesize) + 1"/> of <xsl:value-of select="ceiling($hits div $pagesize)"/></i></td>
                     <xsl:choose>
                        <xsl:when test="$startpage > 1">
                           <td align="right" bgcolor="#ffaaaa" width="120"><a href="#" onClick="document.page2.start.value={floor($start div $pagesize)};document.page2.submit()">previous page</a></td>
                        </xsl:when>
                        <xsl:otherwise>
                           <td align="right" bgcolor="#ffaaaa" width="120">previous page</td>
                        </xsl:otherwise>
                     </xsl:choose>
                     <td align="right" bgcolor="#ffaaaa" width="120">go to page <input name="start" type="text" value="{floor($start div $pagesize) + 1}" size="3"/></td>
                     <xsl:choose>
                        <xsl:when test="$hits > $stop">
                           <td align="left" bgcolor="#ffaaaa" width="120"><a href="#" onClick="document.page2.start.value={floor($start div $pagesize) + 2};document.page2.submit()">next page</a></td>
                        </xsl:when>
                        <xsl:otherwise>
                           <td align="left" bgcolor="#ffaaaa" width="120">next page</td>
                        </xsl:otherwise>
                     </xsl:choose>
                  </tr>
               </table>
            </form>
         </xsl:if>

         <ul>
            <xsl:for-each select="$replies/oailr:record/oailr:metadata/discuss:discuss">
               <xsl:choose>
                  <xsl:when test="$minlevel">
                     <xsl:call-template name="spacer">
                        <xsl:with-param name="number" select="../../oailr:about/level:level - $minlevel - 1"/>
                     </xsl:call-template>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:call-template name="spacer">
                        <xsl:with-param name="number" select="../../oailr:about/level:level - 1"/>
                     </xsl:call-template>
                  </xsl:otherwise>
               </xsl:choose>
               &#x00bb; <a href="forum.pl?identifier={../../oailr:header/oailr:identifier}">
                   <xsl:choose>
                      <xsl:when test="string-length(discuss:subject)=0">
                         [no subject]
                      </xsl:when>
                      <xsl:otherwise>
                         <xsl:value-of select="discuss:subject"/>
                      </xsl:otherwise>
                   </xsl:choose>
               </a> -- 
               <b><xsl:value-of select="discuss:from"/></b> --
               <i><xsl:value-of select="discuss:datestamp"/></i>
               <br/><xsl:choose>
                  <xsl:when test="$minlevel">
                     <xsl:call-template name="spacer2">
                        <xsl:with-param name="number" select="../../oailr:about/level:level - $minlevel - 1"/>
                     </xsl:call-template>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:call-template name="spacer2">
                        <xsl:with-param name="number" select="../../oailr:about/level:level - 1"/>
                     </xsl:call-template>
                  </xsl:otherwise>
               </xsl:choose>
            </xsl:for-each>
         </ul>
         <xsl:if test="$hits > $pagesize">
            <form action="forum.pl" name="page">
               <input type="hidden" name="identifier" value="{$identifier}"/>
               <table cellpadding="4" cellspacing="3" border="0" width="100%" align="center">
                  <tr>
                     <td align="left" bgcolor="#ffaaaa" width="*"><i>displaying page <xsl:value-of select="floor($start div $pagesize) + 1"/> of <xsl:value-of select="ceiling($hits div $pagesize)"/></i></td>
                     <xsl:choose>
                        <xsl:when test="$startpage > 1">
                           <td align="right" bgcolor="#ffaaaa" width="120"><a href="#" onClick="document.page.start.value={floor($start div $pagesize)};document.page.submit()">previous page</a></td>
                        </xsl:when>
                        <xsl:otherwise>
                           <td align="right" bgcolor="#ffaaaa" width="120">previous Page</td>
                        </xsl:otherwise>
                     </xsl:choose>
                     <td align="right" bgcolor="#ffaaaa" width="120">go to page <input name="start" type="text" value="{floor($start div $pagesize) + 1}" size="3"/></td>
                     <xsl:choose>
                        <xsl:when test="$hits > $stop">
                           <td align="left" bgcolor="#ffaaaa" width="120"><a href="#" onClick="document.page.start.value={floor($start div $pagesize) + 2};document.page.submit()">next page</a></td>
                        </xsl:when>
                        <xsl:otherwise>
                           <td align="left" bgcolor="#ffaaaa" width="120">next page</td>
                        </xsl:otherwise>
                     </xsl:choose>
                  </tr>
               </table>
            </form>
         </xsl:if>
         
         </td></tr></table></center>
      </xsl:if>
      
      <hr/>
      
      <b>
      <xsl:choose>
         <xsl:when test="$identifier='top'">
            post new message
         </xsl:when>
         <xsl:otherwise>
            post reply
         </xsl:otherwise>
      </xsl:choose>
      </b>
      <a name="post"/>
      <form action="forum.pl">
         <input type="hidden" name="set" value="{$identifier}"/>
         <br/>from : <input type="text" name="username" size="40"/>
         <br/>subject : 
         <xsl:choose>
            <xsl:when test="$message/oaigr:record/oaigr:metadata/discuss:discuss/discuss:subject">
               <input name="subject" size="40" value="Re: {$message/oaigr:record/oaigr:metadata/discuss:discuss/discuss:subject}"/>
            </xsl:when>
            <xsl:otherwise>
               <input name="subject" size="40"/>
            </xsl:otherwise>
         </xsl:choose>
         <br/>message :
         <br/><textarea name="body" rows="10" cols="60" wrap="virtual"/>
         <p><input name="action" type="submit" value="post message"/></p>
      </form>

   </xsl:template>
   
   <xsl:template match="discuss:from">
      <xsl:value-of select="."/>
   </xsl:template>
      
   <xsl:template name="spacer">
      <xsl:param name="number"/>
      <xsl:if test="$number > 0">
         <xsl:text disable-output-escaping="yes">&lt;div class="messidx"></xsl:text>
         <xsl:call-template name="spacer">
            <xsl:with-param name="number" select="$number - 1"/>
         </xsl:call-template>
      </xsl:if>
   </xsl:template>

   <xsl:template name="spacer2">
      <xsl:param name="number"/>
      <xsl:if test="$number > 0">
         <xsl:text disable-output-escaping="yes">&lt;/div></xsl:text>
         <xsl:call-template name="spacer2">
            <xsl:with-param name="number" select="$number - 1"/>
         </xsl:call-template>
      </xsl:if>
   </xsl:template>

</xsl:stylesheet> 

